from .models import Leg, TreatmentPlan, platformPosition
from django import forms


class LegForm(forms.ModelForm):
    length = forms.CharField()

    def __init__(self, *args, **kwargs):
        super(LegForm, self).__init__(*args, **kwargs)
        ## add a "form-control" class to each form input
        ## for enabling bootstrap
        for name in self.fields.keys():
            self.fields[name].widget.attrs.update({
                'class': 'form-control',
            })

    class Meta:
        model = Leg
        fields = ("__all__")

class TreatmentForm(forms.ModelForm):
    class Meta:
        model = TreatmentPlan
        fields = ('treatmentplan',)

class platformPositionForm(forms.ModelForm):
    x = forms.CharField()
    y = forms.CharField()
    z = forms.CharField()
    roll = forms.CharField()
    pitch = forms.CharField
    yaw = forms.CharField()

    def __init__(self, *args, **kwargs):
        super(platformPositionForm, self).__init__(*args, **kwargs)
        ## add a "form-control" class to each form input
        ## for enabling bootstrap
        for name in self.fields.keys():
            self.fields[name].widget.attrs.update({
                'class': 'form-control',
            })

    class Meta:
        model = platformPosition
        fields = ("__all__")