from socket import *
import numpy as np
from threading import Thread
from. import models
from. import forwardKinematics

udp_socket = socket(AF_INET, SOCK_DGRAM)
udp_socket.settimeout(1)
udp_socket.bind(('0.0.0.0', 60028))
arduino_ip = '192.168.10.240'
arduino_port = 8888
offset = 265
#Recieves leg lengths from the Arduino and stores them in a model
#The function also calculates the current platform position
#based on the leg lengths
def runkinematics():
    class communication(Thread):
        def run(self):
            while(True):
                try:
                    inbound_message, remote_address = udp_socket.recvfrom(1024)
                    decoded_message = np.array(
                        inbound_message.decode('ascii').split(',')).astype(float)
                    data1 = models.Leg(id=1, name="leg1",
                                       length=decoded_message[0]+offset)
                    data1.save()
                    data2 = models.Leg(id=2, name="leg2",
                                       length=decoded_message[1]+offset)
                    data2.save()
                    data3 = models.Leg(id=3, name="leg3",
                                       length=decoded_message[2]+offset)
                    data3.save()
                    data4 = models.Leg(id=4, name="leg4",
                                       length=decoded_message[3]+offset)
                    data4.save()
                    data5 = models.Leg(id=5, name="leg5",
                                       length=decoded_message[4]+offset)
                    data5.save()
                    data6 = models.Leg(id=6, name="leg6",
                                       length=decoded_message[5]+offset)
                    data6.save()
                except Exception as e:
                    pass
                lengths = models.Leg.objects.all().values()
                leglengths = np.zeros(6)
                for i in range(6):
                    leglengths[i] = lengths[i]['length']
                platformposition = forwardKinematics.forwardkinematics(leglengths)

                position = models.platformPosition(id=1, x=platformposition[0],
                                                   y=platformposition[1],
                                                   z=platformposition[2],
                                                   roll=platformposition[3],
                                                   pitch=platformposition[4],
                                                   yaw=platformposition[5])
                position.save()
    communication().start()


