import PyPDF2
from django.conf import settings
import datetime
from socket import *
from threading import Thread
from. import forwardKinematics
from. import models
import numpy as np

def sendpositions(treatmentplan):
    # Communication with the Arduino
    udp_socket = socket(AF_INET, SOCK_DGRAM)
    arduino_ip = '192.168.10.240'
    arduino_port = 8888

    #Reading and dividing up the daily steps into hourly steps
    pdffile = open(settings.MEDIA_ROOT + "/" + str(treatmentplan), 'rb')
    pdfreader = PyPDF2.PdfFileReader(pdffile)
    pdfpage = pdfreader.getPage(0)
    pagetext = str(pdfpage.extractText())
    prescription = pagetext.split("Prescription")
    prescription = prescription[2].split("Strut Change-Outs")
    prescription = prescription[0].split()
    offset = -265
    list = []
    for text in prescription:
        try:
            if int(text) > 30:
                list.append(int(text)+offset)
        except:
            pass
    pdffile.close()
    plan = []
    for i in range(int((len(list)/6))-1):
        for y in range(24):
            for x in range(6):
                diff = (list[i * 6 + x + 6] - list[i * 6 + x])/24
                plan.append(list[i * 6 + x]+diff*y)
    for i in range(-6, 0):
        plan.append(list[i])

    class communication(Thread):
        def run(self):
            global startButton
            interval = datetime.datetime.min
            startButton = False
            step = 0
            #CSV-files used for logging platform position
            file_set = open("set_position.csv", 'w')
            file_set.close()
            file_actual = open("actual_position.csv", "w")
            file_actual.close()
            while True:
                #If the start-button has been pressed and not the stop-button
                if startButton:
                    #Send new position every second
                    if datetime.datetime.now() >= interval:
                        interval = datetime.datetime.now() + datetime.timedelta(seconds=1)
                        list = ""
                        for i in range(6):
                            list += str((plan[6 * step + i]))
                            if i != 5:
                                list += ","
                        lengths = models.Leg.objects.all().values()
                        leglengths = np.zeros(6)
                        planlengths = np.zeros(6)
                        listlist = list.split(",")
                        for i in range(6):
                            leglengths[i] = lengths[i]['length']
                            planlengths[i] = float(listlist[i]) - offset
                        #Logging off the set- and actual position
                        file_set = open("set_position.csv", 'a')
                        file_set.write(
                            str(forwardKinematics.forwardkinematics(planlengths)) + "\n")
                        file_set.close()
                        file_actual = open("actual_position.csv", "a")
                        file_actual.write(
                            str(forwardKinematics.forwardkinematics(leglengths)) + "\n")
                        file_actual.close()

                        #Send new set-position to Arduino
                        udp_socket.sendto(str(list).encode(), (arduino_ip, arduino_port))
                        step += 1

                    #Send stop to the Arduino if the treatment plan has finished
                    if step >= int(len(plan)/(6)):
                        udp_socket.sendto('stop'.encode(), (arduino_ip, arduino_port))
                        break
    communication().start()


